unit Reg_pgm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  DisplayUnit, KeyCode, SEE, StdCtrls;

type
  TRegMe = class(TForm)
    Label1: TLabel;
    bSendMail: TButton;
    bQuit: TButton;
    eInfo: TMemo;
    eComments: TMemo;
    procedure bQuitClick(Sender: TObject);
    procedure bSendMailClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RegMe: TRegMe;
  SmtpServer : String;
  SmtpFrom : String;
  SmtpTo : String;
  SmtpSubject : String;
  SmtpMessage : String;

implementation

{$R *.DFM}

procedure TRegMe.bQuitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TRegMe.bSendMailClick(Sender: TObject);
var
  Code : Integer;
  MsgSize : Integer;
  ServerPtr : PChar;
  FromPtr : PChar;
  ToPtr : PChar;
  SubjPtr : PChar;
  MsgPtr : PChar;
  NullPtr : PChar;
  NL : String;
begin
  SmtpSubject := 'RegMe Test';
  NL := Chr(13) + Chr(10);
  {create message text - you are limited to 255 characters in Delphi 1 !}
  SmtpMessage := 'RegMe Example Program.' + NL + NL
   + 'Each line of this message should be less than 76' + NL
   + 'characters wide and terminated by a carriage return' + NL
   + 'linefeed pair. Wider messages can be sent provided' + NL
   + 'that quoting (SEE_QUOTED_PRINTABLE) is enabled.' + NL + NL
   + NL + eComments.Text + Chr(0);
  {attach SEE}
  Code := seeAttach(1, SEE_KEY_CODE);
  if Code < 0 then
    begin
      Text := Format('Cannot attach SEE (error %d)',[Code]);
      DisplayLine(RegMe.eInfo, Text);
      exit;
    end;  
  {prepare parameters}
  GetMem(FromPtr, 64); StrPCopy(FromPtr, SmtpFrom);
  GetMem(ToPtr, 64); StrPCopy(ToPtr, SmtpTo);
  GetMem(ServerPtr, 64); StrPCopy(ServerPtr, SmtpServer);
  GetMem(NullPtr, 4);  StrPCopy(NullPtr, '');
  {connect to POP3 server}
  SCREEN.Cursor := crHourGlass;
  bSendMail.Enabled := false;
  DisplayLine(RegMe.eInfo,Format('Connecting to %s',[StrPas(ServerPtr)]));
  Code := seeSmtpConnect(0,ServerPtr, FromPtr, NullPtr);
  {free buffers}
  FreeMem(ServerPtr,64); FreeMem(FromPtr,64);
  {any errors ?}
  If Code < 0 then
    begin
      DisplayString(RegMe.eInfo,'seeSmtpConnect: ');
      DisplayError(RegMe.eInfo, Code);
      seeClose(0);
      exit;
    end;
  {ready to send mail}
  DisplayLine(RegMe.eInfo,'Connected.');
  {allocate Message and Subject pointers}
  GetMem(SubjPtr, 64); StrPCopy(SubjPtr, SmtpSubject);
  MsgSize := Length(SmtpMessage);
  GetMem(MsgPtr, MsgSize+1); StrPCopy(MsgPtr, SmtpMessage);
  {send the email}
  DisplayLine(RegMe.eInfo,'Sending mail...');
  Code := seeSendEmail(0,ToPtr,NullPtr,NullPtr,SubjPtr,MsgPtr,NullPtr);
  {free buffers}
  FreeMem(ToPtr,64); FreeMem(SubjPtr,64); FreeMem(MsgPtr,MsgSize+1);
  {any errors ?}
  If Code < 0 then
    begin
      DisplayString(RegMe.eInfo, 'SendEmail: ');
      DisplayError(RegMe.eInfo, Code);
      SCREEN.Cursor := crDefault;
      seeClose(0);
      exit;
    end;
  SCREEN.Cursor := crDefault;
  bSendMail.Enabled := true;
  DisplayLine(RegMe.eInfo,'Email has been sent.');
  seeClose(0);
  seeRelease;
end;

procedure TRegMe.FormCreate(Sender: TObject);
begin
  {PROGRAMMER: Edit the following 3 lines}
  SmtpServer := 'mail.hiwaay.net';
  SmtpFrom := '<reg_me@marshallsoft.com>';
  SmtpTo := '<msc@traveller.com>';
  DisplayLine(RegMe.eInfo, 'Server ' + SmtpServer);
  DisplayLine(RegMe.eInfo, 'From ' + SmtpFrom);
  DisplayLine(RegMe.eInfo, 'To ' + SmtpTo);
  DisplayLine(RegMe.eInfo, 'Enter comments below and push "SendMail".');
end;

end.
