unit see;

interface

const

  SEE_MIN_RESPONSE_WAIT  = 1;
  SEE_MAX_RESPONSE_WAIT  = 2;
  SEE_CONNECT_WAIT       = 3;
  SEE_DISABLE_MIME       = 4;
  SEE_MIN_LINE_WAIT      = 5;
  SEE_MAX_LINE_WAIT      = 6;
  SEE_QUOTED_PRINTABLE   = 8;
  SEE_AUTO_CALL_DRIVER   = 9;
  SEE_FILE_PREFIX       = 10;
  SEE_MAX_SMTP_WAIT     = 11;
  SEE_MAX_POP3_WAIT     = 12;
  SEE_SLEEP_TIME        = 13;
  SEE_DECODE_UNNAMED    = 14;
  SEE_SMTP_PORT         = 15;
  SEE_POP3_PORT         = 16;
  SEE_MAX_LINE_LENGTH   = 17;
  SEE_BLOCKING_MODE     = 18;
  SEE_ALLOW_8BITS       = 19;
  SEE_LOG_FILE          = 20;
  SEE_HIDE_SAVED_MSG    = 21;
  SEE_HIDE_TO_ADDR      = 22;

  SEE_GET_ERROR_TEXT    = 1;
  SEE_GET_COUNTER       = 2;
  SEE_GET_RESPONSE      = 3;
  SEE_GET_SOCK_ERROR    = 4;

  SEE_GET_MESSAGE_BYTES_READ  = 10;
  SEE_GET_ATTACH_BYTES_READ   = 11;
  SEE_GET_TOTAL_BYTES_READ    = 12;
  SEE_GET_MESSAGE_BYTES_SENT  = 13;
  SEE_GET_ATTACH_BYTES_SENT   = 14;
  SEE_GET_TOTAL_BYTES_SENT    = 15;
  SEE_GET_VERSION             = 16;
  SEE_GET_MSG_COUNT           = 17;
  SEE_GET_MSG_SIZE            = 18;
  SEE_GET_BUFFER_COUNT        = 19;
  SEE_GET_CONNECT_STATUS      = 20;
  SEE_GET_REGISTRATION        = 21;
  SEE_GET_ATTACH_COUNT        = 22;
  SEE_GET_LAST_RESPONSE       = 23;
  SEE_GET_VERIFY_STATUS       = 24;
  SEE_GET_SERVER_IP           = 25;
  SEE_GET_BUILD               = 26;
  SEE_GET_SOCKET              = 27;

  SEE_SET_REPLY               = 50;
  SEE_SET_HEADER              = 51;

  QUOTED_OFF   = 0;
  QUOTED_PLAIN = 1;
  QUOTED_HTML  = 2;

function seeAttach(NbrChans : Integer; KeyCode : LongInt) : Integer; stdcall;
function seeClose(Chan : Integer) : Integer; stdcall
function seeDebug(Chan : Integer; Index : Integer;  Buffer : PChar;  BufLen : Integer) : Integer; stdcall
function seeDecodeBuffer(CodedBuf : PChar; ClearBuf : PChar; BufLen : Integer) : Integer; stdcall
function seeDeleteEmail(Chan : Integer; MsgNbr : Integer) : Integer; stdcall
function seeDriver(Chan : Integer) : Integer; stdcall
function seeEncodeBuffer(ClearBuf : PChar; CodedBuf : PChar; BufLen : Integer) : Integer; stdcall
function seeErrorText(Chan : Integer; Code : Integer;  Buffer : PChar;  BufLen : Integer) : Integer; stdcall
function seeExtractLine(Source : PChar; LineNbr : Integer; Buffer : PChar; BufLen : Integer) : Integer; stdcall
function seeExtractText(Source, Text, Buffer : PChar; BufLen : Integer) : Integer; stdcall
function seeGetEmailCount(Chan : Integer) : Integer; stdcall
function seeGetEmailFile(Chan : Integer; MsgNbr : Integer;  FileName, EmailDir, AttachDir : PChar) : Integer; stdcall
function seeGetEmailLines(Chan : Integer; MsgNbr, Lines : Integer;  Buffer : PChar;  BufLen : Integer) : Integer; stdcall
function seeGetEmailSize(Chan : Integer; MsgNbr : Integer) : LongInt; stdcall
function seeGetEmailUID(Chan : Integer; MsgNbr : Integer; Buffer : PChar; BufLen : Integer) : Integer; stdcall
function seeIntegerParam(Chan : Integer; Index : Integer;  Value : LongInt) : Integer; stdcall
function seePop3Connect(Chan : Integer; Server, User, Password : PChar) : Integer; stdcall
function seeRelease : Integer; stdcall;
function seeSendEmail(Chan : Integer; Rcpt, CC, BCC , Subj, Msg, Attach : PChar) : Integer; stdcall
function seeSmtpConnect(Chan : Integer; Server, From, Reply : PChar) : Integer; stdcall
function seeStatistics(Chan : Integer; Index : Integer) : Integer; stdcall
function seeStringParam(Chan : Integer; Index : Integer;  Value : PChar) : Integer; stdcall
function seeVerifyFormat(EmailAddr : PChar) : Integer; stdcall
function seeVerifyUser(Chan : Integer; EmailAddr : PChar) : Integer; stdcall

implementation

function seeAttach; external 'SEE32.DLL';
function seeClose; external 'SEE32.DLL';
function seeDebug; external 'SEE32.DLL';
function seeDecodeBuffer; external 'SEE32.DLL';
function seeDeleteEmail; external 'SEE32.DLL';
function seeDriver; external 'SEE32.DLL';
function seeEncodeBuffer; external 'SEE32.DLL';
function seeErrorText; external 'SEE32.DLL';
function seeExtractLine; external 'SEE32.DLL';
function seeExtractText; external 'SEE32.DLL';
function seeGetEmailCount; external 'SEE32.DLL';
function seeGetEmailFile; external 'SEE32.DLL';
function seeGetEmailLines; external 'SEE32.DLL';
function seeGetEmailSize; external 'SEE32.DLL';
function seeGetEmailUID; external 'SEE32.DLL';
function seeIntegerParam; external 'SEE32.DLL';
function seePop3Connect; external 'SEE32.DLL';
function seeRelease; external 'SEE32.DLL';
function seeSendEmail; external 'SEE32.DLL';
function seeSmtpConnect; external 'SEE32.DLL';
function seeStatistics; external 'SEE32.DLL';
function seeStringParam; external 'SEE32.DLL';
function seeVerifyFormat; external 'SEE32.DLL';
function seeVerifyUser; external 'SEE32.DLL';
end.




